<?PHP

/*
   PHP SCIENCE LABS

   THIS PROGRAM DISPLAYS A A PARALLEL
   JULIAN/GREGORIAN CALENDAR DISPLAY.

   AUTHOR   : Jay Tanner
   LANGUAGE : PHP 5.3.x - Revised with PHP v7.4.9
*/


// -----------------------------------------------
// INITIALIZE OUTPUT BUFFER FOR COOKIES TO PREVENT
// THE "headers already sent" ERROR.  THIS MUST BE
// THE VERY FIRST COMMAND OF THE PROGRAM.

   ob_start();


   $out1 = $out2 = "";

// GET YEAR IN GMT
   $cYear = gmdate("Y");

   $ProgVersion = "v1.5";

// -----------------------------------------------
// SET THE PATH TO THE PROGRAM TO BE EXECUTED WHEN
// THE SUBMIT BUTTON IS CLICKED.  IN THIS CASE, IT
// IS THIS PROGRAM ITSELF. IT MODIFIES ITSELF EACH
// TIME IT IS CALLED..

   $RunThisProgram = $_SERVER["SCRIPT_NAME"];

// -----------------------------------------------------
// DEFINE A NAME FOR THE COOKIE AND SET EXPIRATION DATE
// TO 30 DAYS IF NOT USED OR DELETED BEFORE THEN.  THIS
// VALUE IS EXPRESSED IN SECONDS FROM THE TIME THAT THE
// COOKIE IS CREATED.  THE VALUE 30*86400 MEANS 30 DAYS
// AT 86400 SECONDS PER DAY, FROM THE time() NOW.

   $CookieName = "Parallel_JG_Calendar_Calculator_Settings";

   $ExpirationDateCode = time() + 30*86400;

// ---------------------------------------
// SET INTERNAL TITLE OF HTML OUTPUT PAGE.

   $HTMLTitle = "Parallel Julian/Gregorian Calendars";

// --------------------------------------------------------------
// SET TITLE/HEADING TO BE DISPLAYED AT THE TOP OF THE INTERFACE.

   $InterfaceTitle = "Parallel Julian / Gregorian Calendar Calculator<BR>For Any Given Date On Either Calendar";




// -------------------------------------------------
// CHECK IF OR NOT THE [Compute] BUTTON WAS CLICKED.


   if (!isset($_POST["ComputeButton"]))
{

// ----------------------------------------
// DO THIS IF [Compute] BUTTON WAS CLICKED.
//
// IF A COOKIE EXISTS, THEN READ IT AND
// RESET THE PREVIOUS INTERFACE VALUES.

   if (isset($_COOKIE[$CookieName]))
      {
       $CookieDataString = $_COOKIE[$CookieName];

       list ($y,$m,$d,$RBState1,$RBState2,$CalMode)
       = preg_split("[\|]", $CookieDataString);

       $m = sprintf("%02d", $m);
       $d = sprintf("%02d", $d);
       $ISOymd = "$y$m$d";
       $CalendarMode = ($CalMode == 0) ? "Julian" : "Gregorian";
      }


   else


// -------------------------------------------------
// IF INITIAL STARTUP AND NO COOKIE EXISTS, THEN SET
// DEFAULT INTERFACE VALUES TO UNIVERSAL DATE AT 00h
// AND STORE IN COOKIE SET TO EXPIRE IN 30 DAYS.

   {
      $y = gmdate("Y");
      $m = gmdate("m");
      $d = gmdate("d");
    $ISOymd = "$y$m$d";


    $RBState1 = "";
    $RBState2 = "CHECKED";
    $CalMode  = 1;
    $CalendarMode = "Gregorian";

    $CookieDataString  = "$y|$m|$d|$RBState1|$RBState2|$CalMode";

    setcookie ("$CookieName", $CookieDataString, $ExpirationDateCode);
   }

}




// =============================================
// IF THE [Compute] BUTTON WAS CLICKED, READ AND
// SAVE THE INTERFACE SETTINGS TO A COOKIE.

   if (isset($_POST['ComputeButton']))
{

//     ------------------------------------
//     READ AND TIDY CURRENT DATE SETTINGS.

       $y = trim($_POST['y']);
       $m = trim($_POST['m']);
       $d = trim($_POST['d']);

       if ($y == '' and $m == '' and $d == '')
          {$y = gmdate('Y');   $m = gmdate('m'); $d = gmdate('d');}


       $d = sprintf("%02d", $d);
       $m = sprintf("%02d", $m);
       $ISOymd = "$y$m$d";


// ===========================
// READ CALENDAR MODE SETTING.
//
// 0=Julian  or  1=Gregorian=Default

   $RBIndex = $_POST['RB'];

   if ($RBIndex == 0)
      {
       $CalMode = 0;
       $RBState2 = "";
       $RBState1 = " CHECKED";
       $CalendarMode = "Julian";
      }

   else

      {
       $CalMode = 1;
       $RBState2 = " CHECKED";
       $RBState1 = "";
       $CalendarMode = "Gregorian";
      }

// ============================================================
// COLLECT INTERFACE VALUES AND SETTINGS IN COOKIE DATA STRING
// WITH EACH DATA ELEMENT DELIMITED BY A BAR | CHARACTER.

   $CookieDataString  = "$y|$m|$d|$RBState1|$RBState2|$CalMode";

// ==============================
// SAVE THE SETTINGS IN A COOKIE.

   setcookie ("$CookieName", $CookieDataString, $ExpirationDateCode);

}






// -----------------------------------------------
// CHECK FOR, BLOCK AND REPORT INVALID DATE INPUT,
// OTHERWISE CONTINUE.

   if (Is_Valid_Date($ISOymd, $CalMode))

  {

   $s = "";


// ----------------------------
// CONTINUE HERE IF DATE IS OK.
// OTHERWISE, SKIP THIS AND DO
// SUBSEQUENT else BLOCK.


// ----------------------------------
// COMPUTE JULIAN DAY NUMBERS FOR 12h
// AND 00h ON THE GIVEN DATE.

   $JD12 = JD_For_ISOymd($ISOymd, $CalMode);

   $JD00 = $JD12 - 0.5;


// ----------------------------------------------
// COMPUTE TIME IN JULIAN CENTURIES AND MILLENNIA
// CORRESPONDING TO JD00 AND RECKONED FROM J2000.0

   $T = bcDiv(bcSub($JD00, 2451545, 16), "36525", 12);

   $t = bcDiv($T, "10", 12);

   $T12 = bcDiv(bcSub($JD12, 2451545, 12), "36525", 12);

   $t12 = bcDiv($T12, "10", 12);



//   $DateString = Std_Date_Str_For_ymd ($ISOymd);
   $DateString = Month_String($m) . ' ' . $d . ", $y";


   $DoWString = DoW_Str_For_ISOymd ($ISOymd, $CalMode);

   $NegBCReminder = ($y < 0) ? "(Neg=BC)" : "";

// ---------------------------------------
// CONSTRUCT FORMATTED TEXT OUTPUT BLOCK 1

   $out1 =
"

 DATE = $DateString = $DoWString on the $CalendarMode Calendar &nbsp;

 JD Number = $JD12 on $CalendarMode calendar &nbsp;
           = JD (Julian Date) at 12:00:00 on date &nbsp;

";


/*
TEMP do not print for now:



 =====================
 TECHNICAL INFORMATION

 JD00 = $JD00 = (JD12 - 0.5) at 00h (beginning of date)
      = Standard astronomical JD number for $CalendarMode date

 DYNAMICAL TIME VARIABLE CORRESPONDING TO JD00
 T = $T = Julian centuries reckoned from J2000.0 &nbsp;
 t = $t = Julian millennia reckoned from J2000.0 &nbsp;

 DYNAMICAL TIME VARIABLE CORRESPONDING TO JD12
 T = $T12 = Julian centuries reckoned from J2000.0 &nbsp;
 t = $t12 = Julian millennia reckoned from J2000.0 &nbsp;
*/

// ====================================================
// THE MAIN ASTRONOMICAL COMPUTATIONS BLOCK STARTS HERE
// USING THE VALIDATED INTERFACE SETTINGS VALUES.  THE
// OUTPUT STRING WILL BE IN out2


// ---------------------------------------------------------
// Create calendar for input date and calendar mode followed
// by the other calendar mode.

// For Julian date input:
   if ($CalMode == 0)
   {
   $JulianCalendar = Cal_Table ($ISOymd, "Yellow", 0);
   $GISOymd = ISOymd_For_JD($JD12, 1);
   $GregorianCalendar = Cal_Table ($GISOymd, "Cyan",  1);

   $GminusJ = JD_For_ISOymd($ISOymd, 1) - JD_For_ISOymd($ISOymd, 0);

// Determine if 's' should be attached to 'day' label.
   $s = (abs($GminusJ) != 1) ? "s" : "";

   $GminusJ = sprintf("%+d", $GminusJ);
   $GminusJ = str_replace("-", "- ", $GminusJ);
   $GminusJ = str_replace("+", "+ ", $GminusJ);
   }

   else

// For Gregorian date input:
  {
   $GregorianCalendar = Cal_Table ($ISOymd, "Cyan",   1);
   $JISOymd = ISOymd_For_JD($JD12, 0);
   $JulianCalendar = Cal_Table ($JISOymd,   "Yellow", 0);

   $GminusJ = JD_For_ISOymd($ISOymd, 1) - JD_For_ISOymd($ISOymd, 0);

// Determine if 's' should be attached to 'day' label.
   $s = (abs($GminusJ) != 1) ? "s" : "";

   $GminusJ = sprintf("%+d", $GminusJ);
   $GminusJ = str_replace("-", "+ ", $GminusJ);
   $GminusJ = str_replace("+", "- ", $GminusJ);
   }


   $out1 .= " Julian Calendar Date = Gregorian Calendar Date $GminusJ day$s&nbsp;\n\n";
   $out1 .= " Note that the corresponding days of the week are the same on both&nbsp;\n calendars";
   $out1 .= " no matter the number of days difference between them.&nbsp;\n\n";

   $out1 = Str_Replace('Gregorian Calendar Date -  ', 'Gregorian Calendar Date - ', $out1);

  } // THE MAIN ASTRONOMICAL COMPUTATIONS BLOCK ENDS HERE.


else

// --------------------------------------
// DO THIS IF THE GIVEN DATE WAS INVALID.
//
// REPORT INVALID DATE ERROR IN out2

  {
   $JulianCalendar = $GregorianCalendar = "";
   $out1 = "&nbsp;ERROR: Invalid date on $CalendarMode calendar.&nbsp;";
   $out2 = "";
  }









// ===========================================================
// THE DYNAMIC HTML OUTPUT DOCUMENT FOLLOWS BELOW AND CONTAINS
// THE EMBEDDED VARIABLES DEFINED AND COMPUTED ABOVE.  THESE
// EMBEDDED VARIABLES ARE IDENTIFIED BY THE DOLLAR SIGN SYMBOL
// $ THAT IS ATTACHED TO THEM.
//
// THE CSS STYLES ARE PUT INSIDE THE DOCUMENT FOR CONVENIENCE,
// BUT CAN BE MOVED TO AN EXTERNAL CSS SHEET IF DESIRED.

print <<< _HTML

<!DOCTYPE HTML>

<HTML lang='en'>

<HEAD>

<title>Parallel Julian/Gregorian Calendar Calculator</title>

<meta name='viewport' content='width=device-width, initial-scale=1'>
<meta http-equiv='content-type' content='text/html; charset=UTF-8'>
<meta name='description' content='This PHP program is a parallel Julian/Gregorian calendar calculator.'>
<meta name='keywords' content='Julian,Gregorian,Julian calendar,Gregorian calendar,calendar,PHPScienceLabs.com'>
<meta name='author' content='Jay Tanner - www.PHPScienceLabs.com'>
<meta http-equiv='pragma'  content='no-cache'>
<meta http-equiv='expires' content='-1'>
<meta name='robots'    content='index,follow'>
<meta name='googlebot' content='index,follow'>
<link rel="canonical" href="https://www.phpsciencelabs.com/parallel-julian-and-gregorian-calendar-calculator/">

<style>

PRE {color:black; background:white; font-family:monospace; font-size:135%; font-weight:bold; border-radius: 8px; border:1px solid black; padding:6px; white-space:pre;}

INPUT[type='submit']{background:silver; color:black; font-family:Verdana; font-size:100%; font-weight:normal; border-radius:4px; border:1px solid black; padding:2px;}
INPUT[type='submit']:hover{background:cyan; font-family:Verdana; font-size:100%; font-weight:normal; border-radius:4px; border:1px solid black; padding:2px;}

INPUT[type='text']::-ms-clear{width:0; height:0;}
INPUT[type='text']{font-family:monospace; color:black; background:white; font-size:150%; font-weight:bold; text-align:center; box-shadow:2px 2px 3px #666666; border:1px solid black; border-radius:4px;}
INPUT[type='text']:focus{font-family:monospace; background:white; box-shadow:2px 2px 3px #666666; font-size:150%; border:2px solid blue; text-align:center; font-weight:bold; border-radius:4px;}
</style>

<TITLE>$HTMLTitle</TITLE>

</HEAD>

<BODY style='background:black;'>

<div ID=SmoothScroll>
<FORM NAME="InputForm1" METHOD="post" ACTION="$RunThisProgram">

<TABLE WIDTH="590" ALIGN="center" BGCOLOR="black" CELLPADDING="4" CELLSPACING="1">

<TR><TD style='background:#000066; color:white; font-size:125%; border:2px solid white; border-radius:8px 8px 0px 0px;' COLSPAN="3" ALIGN="center">$InterfaceTitle<br><span style='font-size:70%;'>PHP Program by Jay Tanner</span>
</TD></TR>

<TR CLASS="Tx12" style='line-height:150%;'><TD ALIGN="center" BGCOLOR="LightCyan" COLSPAN="3"><B>Calendar Date</B>: &nbsp; &plusmn;Y&nbsp; M&nbsp; D &nbsp; (Neg Year = BC)
<BR>
<INPUT NAME="y" TYPE="text" CLASS="TxInpCtr" VALUE="$y" SIZE="5" MAXLENGTH="5">
<INPUT NAME="m" TYPE="text" CLASS="TxInpCtr" VALUE="$m" SIZE="2" MAXLENGTH="2">
<INPUT NAME="d" TYPE="text" CLASS="TxInpCtr" VALUE="$d" SIZE="2" MAXLENGTH="2">
</TD></TR>




<TR>
<TD COLSPAN="3" ALIGN="center" BGCOLOR="white"><B>Calendar Input Mode</B>: &nbsp;
<INPUT NAME="RB" TYPE="radio" VALUE="0"$RBState1><B CLASS="BgYellow">&nbsp;Julian&nbsp;</B>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<INPUT NAME="RB" TYPE="radio" VALUE="1"$RBState2> <B CLASS="BgCyan">&nbsp;Gregorian&nbsp;</B>
</TD>
</TR>


<TR><TD COLSPAN="3" ALIGN="center" BGCOLOR="black"><INPUT TYPE="submit" NAME="ComputeButton" VALUE="Compute"></TD></TR>


<TR>
<!-- Start of sub-table as table data within a table -->
<TD>
<TABLE BORDER="0" ALIGN="center" BGCOLOR="white" CELLPADDING="2" CELLSPACING="1">
<TD vALIGN="top" BGCOLOR="white">$JulianCalendar</TD><TD VALIGN="top" BGCOLOR="white">$GregorianCalendar</TD>
</TR>
</TABLE>
</TD>
<!-- End of sub-table as table data within a table -->
</TR>

<TR><TD ALIGN="left" BGCOLOR="black">
<PRE CLASS="WorkBlock">$out1</PRE>
</TD></TR>

</TABLE>
</FORM>

<br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br><br>
</div>

<script src='SmoothScroll.js'></script>
<script>SmoothScroll.init({cancelOnTouch: true});</script>

</BODY>
</HTML>

_HTML;



/*
   A DATE AND TIME INTERFACE DRIVER MODULE DESIGNED EXCLUSIVELY FOR PHP 5.3+

   REVISED: 2012 APR 29

   Author:  Jay Tanner

   -------------------------------------------------------------------
   The date system used is the standard, historical BC/AD convention
   with negative values meaning BC dates.  The year 1 BC is followed
   immediately by 1 AD.  By definition, there is no year zero in
   this system.  This is taken into account in the computations.
   -------------------------------------------------------------------

*/




// -----------------------------------
// Speed of light in meters per second

   define ("CLIGHT", "299792458");

// ------------------------------------------
// JULIAN AND GREGORIAN CALENDAR YEAR LENGTHS

// Length of Julian calendar year in seconds.
// Exactly 365.25 days.
   define ("S_PER_JYR", "31557600");

// Length of Gregorian calendar year in seconds.
// Exactly 365.2425 days.
   define ("S_PER_GYR", "31556952");


// -----------------------------------------------------------------
// Define some EXACT standard metric length/distance interconversion
// factors in terms of metres per unit (M_PER_UNIT).  This is the
// factor to multiply the units by to compute the equivalent metres.

   define ("M_PER_A"   , "0.0000000001");  // m per angstrom
   define ("M_PER_NM"  , "0.000000001");   // m per nanometer
   define ("M_PER_UM"  , "0.000001");      // m per micrometer (micron)
   define ("M_PER_MM"  , "0.001");         // m per millimeter
   define ("M_PER_CM"  , "0.01");          // m per centimeter
   define ("M_PER_IN"  , "0.0254");        // m per inch
   define ("M_PER_FT"  , "0.3048");        // m per foot
   define ("M_PER_YD"  , "0.9144");        // m per yard
   define ("M_PER_M"   , "1");             // m per meter
   define ("M_PER_KM"  , "1000");          // m per kilometer
   define ("M_PER_MI"  , "1609.344");      // m per mile (statute)
   define ("M_PER_NMI" , "1852");          // m per nautical mile
   define ("M_PER_LS", "299792458");       // Meters per Light Second

   define ("KM_PER_NMI", "1.852");         // km per nautical mile
   define ("KM_PER_MI" , "1.609344");      // Kilometres per Mile (statute)



// ------------------------
// Define Astronomical Unit

   define ("M_PER_AU" ,  "149597870691");   // NASA/JPL-DE405
   define ("KM_PER_AU",  "149597870.691");  // ibid.
   define ("KM_PER_IAU", "149597871");      // IAU value




// -----------------------------------------------------
// Derived factors based on the above adopted standards.
// The AU used is the IAU value and the year value used
// is the standard Julian year of exactly 365.25 days.

   define ("M_PER_LY"  , "9460730472580800");
   define ("M_PER_PC"  , "30856775876793114.663268286124906723306552690712989");
   define ("AU_PER_LY" , "63241.0769574441336802");
   define ("AU_PER_PC" , "206264.806247096355156473357330778613196659");
   define ("LY_PER_PC" , "3.2615637837080957");

// ------------------------------------------
// Define some EXACT metric weight standards.

   define ("KG_PER_OZ" , "0.028349523125");
   define ("KG_PER_LB" , "0.45959237");
   define ("G_PER_OZ"  , "28.349523125");



// ------------------------------------------------
// Define standard and universal gravity constants.

   define ("g", "9.80665");  // m per s²
   define ("G", "0.000000000066742");  // Universal G (SI units)



// --------------------------
// Define Planck constant (h).

   define ("h", "0.000000000000000000000000000000000662606896");  // J/s (watts)



// -----------------------------------------
// Define Stefan-Boltzmann constant (sigma).
//
// Radiated energy = sigma * K**4 watts per sq. meter
// Where K = temperature in kelvins

   define ("sigma", "0.000000056704");  // Watts per sq. meter


// -----------------------------------------
// Define Boltzmann constant (k).
//
// k = Joules / deg Kelvin

   define ("k", "0.000000000000000000000013806504");  // Joules per deg K

// ****************************************************************************








// ****************************************************************************

/*
   This function computes the calendrical JD number, which is always a positive
   integer (or zero).  This is the JD number used for simple, basic calendrical
   computations where the time of day can be ignored, such as when computing
   the exact number of whole calendar days between two dates.  For example,
   when we want to compute how many days it is until Christmas, we do not
   need to consider the time of day on either of the dates to perform the
   computation - we simply count whole days.

   This JD value  corresponds to the astronomical JD number for 12h, the
   midpoint of the given date.

   To obtain the astronomical JD number for 00h, the beginning of the date,
   simply subtract 0.5 from this integer value.  This is the value to which
   may later be added the fraction of a day corresponding to a given time so
   that we may obtain the general JD number for any given moment of the day.

   ISOymd  = ISO signed integer encoded date

   CalMode = Calendar Mode (0=Julian, 1=Gregorian=Default)

*/

   function JD_For_ISOymd($ISOymd, $CalMode=1)
{

// ----------------------------------------------
// EXTRACT INDIVIDUAL DATE ARGUMENTS (y,m,d) FROM
// WITHIN ISO INTEGER-ENCODED DATE ARGUMENT.

   $u = abs($ISOymd);
   $w = floor($u / 10000);

   $y = (($ISOymd < 0) ? -1 : 1) * $w;
   $m = floor(($u - 10000*$w) / 100);
   $d = $u - 10000*$w - 100*$m;

// -------------------------------------------------
// COMPUTE THE JD NUMBER FOR 12h ON GIVEN DATE. THIS
// NUMBER WILL ALWAYS EQUATE TO AN INTEGER VALUE.

   $w = ($y < 0) ? $y+1 : $y;

   $a = floor((14-$m) / 12);
   $b = $w - $a;
   $c = floor($b/100);

   $JD = floor(30.6001*(12*$a + $m + 1))
       + floor(365.25*($b + 4716)) - 1524
       + $CalMode*(floor($c/4) - $c + 2) + $d;

   return $JD;

} // End of  JD_For_ISOymd()










/*

   This is the inverse JD function.  Given the general JD number and calendar
   mode, it returns the corresponding ISO integer encoded calendar date.

   The JD argument is always positive, but is NOT restricted to only integer
   values and may contain a fractional component corresponding to the time
   of day.


   CalMode = Calendar Mode (0=Julian, 1=Gregorian=Default)

*/

   function ISOymd_For_JD ($JD, $CalMode=1)
{

// ------------------------------------------------------
// COMPUTE JD12 FROM ASTRONOMICAL JD AND THEN COMPUTE THE
// CORRSPONDING ISO INTEGER-ENCODED DATE FOR JD12.

   $a = floor($JD + 0.5);
   $b = $CalMode*floor(($a - 1867216.25) / 36524.25);
   $c = $a + $CalMode*($b - floor($b/4) + 1);
   $e = $c + 1524;
   $f = floor(($e - 122.1) / 365.25);
   $g = floor(365.25 * $f);
   $h = floor(($e - $g) / 30.6001);

   $m = $h - 12*floor($h/14) - 1;
   $d = $e - $g - floor(30.6001 * $h);

   $w = $f - 4716 + floor((14-$m) / 12);

   $y = ($w > 0)? $w : $w-1;

   $YearSign = ($y < 0)? -1 : 1;

   $ISOymd = $YearSign*(10000*abs($y) + 100*$m + $d);

   return $ISOymd;

} // End of  ISOymd_For_JD()

// ****************************************************************************

   function Is_Valid_Date ($ISOymd, $CalMode=1)
{

// --------------------------------------
// Call the JD number function to compute
// the JD number for the given date.

   $JD = JD_For_ISOymd ($ISOymd, $CalMode);

// --------------------------------------------------------------
// Now, reverse the process by calling the inverse JD function to
// compute the ISO integer-encoded date value from the previously
// computed JD value.  The date value we get back should be the
// same date value we used as the input date argument.  Otherwise,
// it means that the given date is invalid.
//
// If the returned date value exactly matches the input date value,
// then the date is OK (TRUE), otherwise the date is invalid (FALSE).

   return (ISOymd_For_JD ($JD, $CalMode) == $ISOymd)? TRUE:FALSE;

} // End of  Is_Valid_Date(...)


// *****************************************************************


/*
   This function computes the fraction of a day equivalent to a given time.
   The time can be a negative or positive value as indicated by SignValue.

   It is intended for times in the range from 0 to ±24h


   SignValue  = 1 for a positive time  or  -1 for a negative time

   hh, mm, ss = Time elements (positive values, NOT restricted to integers)

*/

   function Days_For_HMS ($SignValue, $hh=0, $mm=0, $ss=0)
{

// -----------------------------------
// COMPUTE TIME EQUIVALENT IN SECONDS.

   $TimeInSeconds = bcAdd(bcAdd(bcMul("3600", "$hh", 18), bcMul("60", "$mm", 18)), "$ss", 18);

   $SignSymbol = ($SignValue < 0) ? "-" : "";

   if ($TimeInSeconds == 0) {$SignSymbol = "";}

// -----------------------------------------------
// COMPUTE TIME EQUIVALENT AS A FRACTION OF A DAY.

   $TimeInDays = bcDiv("$TimeInSeconds", "86400", 18);

// --------------------------------------------------
// ROUND OFF TimeInDays AT 16 DECIMALS AND THEN STRIP
// OFF ANY REDUNDANT ZEROS AND/OR DECIMAL POINT.

   $TimeInDays = bcAdd("$TimeInDays", "0.00000000000000005", 16);

   $TimeInDays = RTrim(RTrim($TimeInDays, "0"), ".");

   return "$SignSymbol$TimeInDays";
}

// ****************************************************************************

/*
 THIS FUNCTION TAKES A NUMERIC MONTH ARGUMENT FROM 01 TO 12 AND RETURNS THE
 CORRESPONDING ENGLISH MONTH NAME STRING FROM "January" TO "December".

 ANY ARGUMENT NOT RECOGNIZED AS A NUMBER FROM 1 TO 12 WILL RETURN AN EMPTY
 STRING AS AN ERROR INDICATOR.

*/
   function Month_String ($m)
{

// -------------------------
// DEFINE MONTH NAMES TABLE.

   $months = "January  February March    April    May      June     July     August   SeptemberOctober  November December ";

// -------------------------------------------
// IF MONTH ARGUMENT IS IN THE CORRECT NUMERIC
// RANGE, THEN RETURN THE MONTH NAME STRING.

// UNPAD ANY ZERO-PADDED MONTH VALUE.
   $w = intval(LTrim(trim($m), '0'));

   if ($w > 0 && $w < 13)
      {return trim(substr($months, 9*($w-1), 9));}
   else
      {return "";}


} // End of  Month_String()


// ****************************************************************************


/*
   This function returns the full, English weekday name string for the given
   ISO integer encoded date and calendar mode.


   ISOymd  = ISO signed integer encoded date
   CalMode = Calendar Mode (0=Julian, 1=Gregorian=Default)

*/

   function DoW_Str_For_ISOymd ($ISOymd, $CalMode)
{

// -----------------------------
// COMPUTE JD FOR 12:00 ON DATE.

   $JD12 = JD_For_ISOymd($ISOymd, $CalMode);

// ------------------------
// GET DoW STRING FOR JD12.

   return JDDayOfWeek ($JD12, 1);
}


// ****************************************************************************

   function Deg_For_DMS ($sign, $DMSStr)

{
   $dd = $mm = $ss = 0;

   $SignVal = ($sign === "-" || intval($sign) < 0) ? -1 : 1;

   $w = trim($DMSStr);  if ($w == "") {return "0";}

   $ang = preg_replace('/\s+/', ' ', $w);
   $ang = str_replace("+", "", $ang);
   $ang = str_replace("-", "", $ang);

   $w1 = preg_split("[ ]", $ang);  $AngCount = count($w1);

   @list($dd,$mm,$ss) = preg_split("[ ]", $ang);  $AngCount = count($w1);

   if ($AngCount >= 1) {$w2  = $dd * 3600;}
   if ($AngCount >= 2) {$w2 += $mm * 60;}
   if ($AngCount >= 3) {$w2 += $ss;}

   $AngDeg = $SignVal * ($w2 / 3600);

   return $AngDeg;

} // End of  Deg_For_DMS()



// ****************************************************************************

/*

   This function returns the degrees, minutees and seconds corresponding
   to a given positive or negative decimal degrees argument.

   PosSignFlag = This flag indicates whether or not to attach a positive sign
                 to positive values.

                 TRUE  = Attach a positive sign to all positive values
                 FALSE = Do NOT attach positive sign any positive values


   DegArg = The ± decimal degrees argument (0 to ±360 degrees).


   dddDigits = Number of digits in output degrees value (1 to 3)


   ssDecimals = Decimals at which to round off output seconds value (0 to 3)


   SymbolsFlag = This flag indicates whether or not to attach the symbols for
                 degrees, minutes and seconds (° ' ") to the output DMS string.

                 TRUE  = Attach DMS symbols to output DMS string
                 FALSE = Do NOT attach DMS symbols to output DMS string

*/

   function DMS_For_Deg ($PosSignFlag, $DegArg, $dddDigits, $ssDecimals, $SymbolsFlag=TRUE)
{

// -------------------------------
// HANDLE NUMERICAL SIGN OF INPUT.

   if ($DegArg < 0) {$sign = "-";} else {$sign = "";}

   if ($PosSignFlag === TRUE && $sign != "-")   {$sign = "+";}

// ----------------------------
// WORK WITH THE ABSOLUTE VALUE
// OF ORIGINAL ARGUMENT.  THE
// NUMERICAL SIGN WILL BE
// REAPPLIED TO THE OUTPUT.

   $DegArg = abs($DegArg);

// ----------------
// COMPUTE DEGREES.

   $ddd = floor($DegArg);

// --------------------
// COMPUTE ARC MINUTES.

   $w  = 60*($DegArg - $ddd);
   $mm = (int)$w;

// --------------------
// COMPUTE ARC SECONDS.

   $ss = 60*($w - $mm);

// ----------------------------------
// ADJUST REDUNDANT DDD PADDING ZEROS
// ACCORDING TO ($dddDigits) VALUE.

   if ($dddDigits == 1)
      {$ddd = 0+$ddd;}

   if ($dddDigits == 2)
      {
       if (StrLen($ddd) < 2) {$ddd = "0$ddd";}
      }

   if ($dddDigits == 3)
      {
       if (StrLen($ddd) < 2)  {$ddd = "00$ddd";}
       if (StrLen($ddd) == 2) {$ddd = "0$ddd";}
      }

// ------------------------------------------
// FORMAT ARC MINUTES VALUE ($mm) FOR OUTPUT.

   if ($mm < 10) {$mm = "0$mm";}

// ------------------------------------------
// CONSTRUCT OUTPUT DMS LABELS, IF INDICATED.

   $DDDsymbol = $MMsymbol = $SSsymbol = "";

   if ($SymbolsFlag === TRUE)
      {
       $DDDsymbol = "°";
       $MMsymbol  = "'";
       $SSsymbol  = '"';
      }

// -------------------------------------------
// FORMAT ARC SECONDS VALUE ($ss). FOR OUTPUT.

   $SSformat = "%02." . "$ssDecimals" . "f";

   if ($ssDecimals == 0)
      {$ss = sPrintF("%02d", $ss);
      }
   else
      {
       $ss = sPrintF($SSformat, $ss);
       if ($ss < 10) {$ss = "0$ss";}
      }

// -------------------------------------------
// PATCH FOR THAT BLASTED RESIDUAL 60 PROBLEM.

   if ($ss == 60) {$mm = sprintf("%02d", $mm+1);   $ss = sPrintF($SSformat, 0);}
   if ($mm == 60) {$hh = sprintf("%02d", $hh+1);   $mm = "00";}

// --------------------------------------------------
// RETURN THE FORMATTED "DDD MM SS.sss" ANGLE STRING.

   return "$sign$ddd$DDDsymbol $mm$MMsymbol $ss$SSsymbol";

} // End of  DMS_For_Deg()


// ****************************************************************************

/*

   This function returns the hours, minutes and seconds corresponding to an
   angle argument given in decimal degrees.  360 degrees it taken as equivalent
   to exactly 24 hours which equates to 15 degrees per hour.


   PosSignFlag = This flag indicates whether or not to attach a positive sign
                 to positive output values.

                 TRUE  = Attach a positive sign to all positive output values
                 FALSE = Do NOT attach positive sign any positive output values


   DegArg = The ± decimal degrees argument (0 to ±360 degrees).


   hhDigits = Number of digits in output hours value (1 to 2)


   ssDecimals = Decimals at which to round off output seconds value (0 to 3)


   SymbolsFlag = This flag indicates whether or not to attach the symbols for
                 hours, minutes and seconds (h m s) to the output HMS string.

                 TRUE  = Attach HMS symbols to output HMS string
                 FALSE = Do NOT attach HMS symbols to output HMS string

*/

   function HMS_For_Deg ($PosSignFlag, $DegArg, $hhDigits, $ssDecimals, $SymbolsFlag=TRUE)
{

// -------------------------------
// HANDLE NUMERICAL SIGN OF INPUT.

   if ($DegArg < 0) {$sign = "-";} else {$sign = "";}

   if ($PosSignFlag === TRUE && $sign != "-")   {$sign = "+";}

// ----------------------------
// CONVERT DECIMAL DEGREES INTO
// DECIMAL HOURS AND WORK WITH
// THE ABSOLUTE VALUE.  THE
// SIGN WILL BE REAPPLIED TO
// THE OUTPUT.

   $deg = abs($DegArg / 15);

// --------------
// COMPUTE HOURS.

   $hh = floor($deg);

// ----------------
// COMPUTE MINUTES.

   $w  = 60*($deg - $hh);

   $mm = floor($w);

// ----------------
// COMPUTE SECONDS.

   $ss = 60*($w - $mm);

// --------------------------------
// PATCH TO HANDLE THE 60s PROBLEM.

   if ($ss == 60) {$mm += 1;  $ss = 0;}
   if ($mm == 60) {$hh += 1;  $mm = 0;}

// ------------------------------
// FORMAT HOURS VALUE FOR OUTPUT.

   $hh = sPrintF("%02d", $hh);

// --------------------------------
// FORMAT MINUTES VALUE FOR OUTPUT.

   $mm = sPrintF("%02d", $mm);

// --------------------------------------------
// ATTACH OUTPUT SYMBOLS (H M S), IF INDICATED.

   $HHsymbol = $MMsymbol = $SSsymbol = "";

   if ($SymbolsFlag)
      {
       $HHsymbol = "h";
       $MMsymbol = "m";
       $SSsymbol = "s";
      }

// --------------------------------
// FORMAT SECONDS VALUE FOR OUTPUT.

   $SSformat = "%02." . "$ssDecimals" . "f";
   $ss = sPrintF($SSformat, $ss);
         if ($ss < 10) {$ss = "0$ss";}

// ------------------------------------------------
// RETURN THE FORMATTED "HH MM SS.sss" TIME STRING.

   return "$sign$hh" . "$HHsymbol $mm" .  "$MMsymbol $ss" . "$SSsymbol";

} // End of  HMS_For_Deg()


// ****************************************************************************


/*

   Return hours, minutes and seconds corresponding to a given decimal days
   value.  The argument can be either negative or positive.

   The absolute value of the returned result can be > 24 hours.

   The returned seconds value may be rounded off to up to 3 decimals. If no
   decimals are specified, then the default zero value will be used.

*/

   function HMS_For_Days ($DaysVal, $NumDecimals=0)

{

// ---------------------------
// READ INPUT ARGUMENT VALUES.

   $days = trim($DaysVal);

   $d = floor(abs((trim($NumDecimals))));

// --------------------------------------
// IF DAYS ARGUMENT IS EMPTY, THEN SET TO
// DEFAULT ZERO VALUE.

   if ($days == "") {$days = 0;}

// ---------------------------------------
// IF DECIMALS ARGUMENT IS EMPTY, THEN SET
// TO DEFAULT ZERO VALUE.

   if ($d == "") {$d = 0;}

// ---------------------
// IF DECIMALS > 3, THEN
// SET TO DEFAULT 3 LIMIT.

   if ($d > 3) {$d = 3;}

// ---------------------------
// REMEMBER ANY NEGATIVE SIGN.

   if ($days < 0) {$sign = "-";} else {$sign = "";}

// --------------------------------------------
// WORK WITH ABSOLUTE days VALUE.  ANY NEGATIVE
// SIGN WILL BE PRESERVED IN THE RETURNED RESULT.

   $days = abs($days);

// --------------------
// COMPUTE HOURS VALUE.

   $w   = $days * 24;

   $hh  = floor($w);

// ----------------------
// COMPUTE MINUTES VALUE.

   $w   = 60*($w - $hh);

   $mm  = floor($w);

// ----------------------
// COMPUTE SECONDS VALUE.

   $ss  = 60*($w - $mm);

// -------------------------------------
// ROUND SECONDS VALUE (ss) TO THE GIVEN
// NUMBER OF DECIMALS (d).

   $ss = sprintf ("%01.$d" . "f", $ss);

   if ($ss < 10) {$ss = "0$ss";}

// --------------------------------------
// ACCOUNT FOR THAT ANNOYING 60S PROBLEM.

   if ($ss == 60) {$mm += 1;  $ss = 0;}
   if ($mm == 60) {$hh += 1;  $mm = 0;}

// ------------------------------------
// FORMAT THE TIME ELEMENTS FOR OUTPUT.

   $hh = sprintf("%02d", $hh);
   $mm = sprintf("%02d", $mm);

   $ss = sprintf ("%01.$d" . "f", $ss);

   if ($ss < 10) {$ss = "0$ss";}

// -----------------------------------
// ATTACH HMS SYMBOLS TO TIME ELEMENTS
// AND RECALL NUMERICAL SIGN.

   $hh .= "h";  $mm .= "m";  $ss .= "s";

   return "$sign$hh $mm $ss";

} // End of  HMS_For_Days()


// ****************************************************************************

/*

   This function returns the correction in degrees to be  applied to the
   ecliptical longitude to reduce it from the VSOP87 dynamical system to
   the FK5 system of coordinates.

*/

   Function FK5_Lng_Corr ($JD, $EclLngDeg, $EclLatDeg)

{

// -----------------------------------------
// COMPUTE TIME RECKONED IN JULIAN CENTURIES
// FROM J2000.0 CORRESPONDING TO THE JD

   $T = ($JD - 2451545.0) / 36525;

// ----------------------------------
// READ ECLIPTICAL LATITUDE ARGUMENT.

   $b = deg2rad($EclLatDeg);

   $Lprime = deg2rad($EclLngDeg - 1.397*$T - 0.00031*$T*$T);

// ----------------------------------------
// COMPUTE LONGITUDE CORRECTION IN DEGREES.

   $w = (0.03916*(cos($Lprime) + sin($Lprime))*tan($b) - 0.09033) / 3600;

// --------------------
// RETURN THE LONGITUDE
// CORRECTION.

   return $w;

} // End of  FK5_Lng_Corr()


/*
   --------------------------------------------
   THIS FUNCTION RETURNS THE CORRECTION TO BE
   APPLIED TO THE ECLIPTICAL LATITUDE TO REDUCE
   IT FROM THE VSOP87 DYNAMICAL SYSTEM TO THE
   FK5 SYSTEM OF COORDINATES.

*/

   Function FK5_Lat_Corr ($JD, $EclLngDeg)
{

// -----------------------------------------
// COMPUTE TIME RECKONED IN JULIAN CENTURIES
// FROM J2000.0 CORRESPONDING TO THE JD

   $T = ($JD - 2451545) / 36525;

// ------------------------------------------
// COMPUTE AUXILIARY WORKING ANGLEIN RADIANS.

   $u = deg2rad($EclLngDeg - 1.397*$T - 0.00031*$T*$T);

// -------------------------------------------------
// DONE.  RETURN THE LATITUDE CORRECTION IN DEGREES.

   return 0.03916*(cos($u) - sin($u)) / 3600;

} // End of  FK5_Lat_Corr()


// ****************************************************************************


   function Ecl_To_Equ_Coords ($EclLngDeg, $EclLatDeg, $EpsDeg)

  {

// ------------------------------
// CONVERT INPUT ECLIPTICAL ANGLE
// ARGUMENTS INTO RADIANS.

   $LngRad = deg2rad($EclLngDeg);
   $LatRad = deg2rad($EclLatDeg);
   $EpsRad = deg2rad($EpsDeg);

// -------------------------------------
// COMPUTE THE EQUATORIAL RA IN DEGREES.

   $y = sin($LngRad)*cos($EpsRad) - tan($LatRad)*sin($EpsRad);

   $x = cos($LngRad);

   $RADeg = rad2deg(atan2($y, $x));

   if ($RADeg < 0) {$RADeg += 360;}

// -----------------------------------
// COMPUTE THE EQUATORIAL DECLINATION.

   $DeclRad = asin(sin($LatRad)*cos($EpsRad) + cos($LatRad)*sin($LngRad)*sin($EpsRad));

   $DeclDeg = rad2deg($DeclRad);

// ---------------------------------------------
// DONE.  RETURN THE RA AND DECLINATION, BOTH IN
// DEGREES, IN A SPACE DELIMITED DATA VECTOR.

   return "$RADeg $DeclDeg";

  } // End of  Ecl_To_Equ_Coords()


// ****************************************************************************


/*

   Compute the mean  obliquity of the ecliptic in degrees for the
   current JD argument corresponding to any given moment.

   This ecliptic obliquity function is based on a formula derived
   by J. Laskar, Astronomy and Astrophysics, 1968, Vol. 157, p68.

   The estimated accuracy of this formula is ±0.01 arc second between
   the years 1000 AD and 3000 AD and a few arc seconds after 10,000
   years.  It is only valid in the range ±10,000 years either way
   of J2000.0

   Over the long term, it is more accurate than the formula
   adopted by the International Astronomical Union (IAU)
   for general ephemeris computations.

   ---------
   ARGUMENTS

   $JD = General JD argument for any date and time.


   ------
   ERRORS

   No error checking is done.

*/


   function Epsilon_Mean ($JD)

{

// ----------------------------------------------
// COMPUTE THE TIME IN JULIAN CENTURIES RECKONED
// FROM J2000.0 CORRESPONDING TO THE JD ARGUMENT
// AND THEN DIVIDE BY 100 FOR DECIMILLENNIA.

   $t = ($JD - 2451545.0) / 36525 / 100;

// --------------------------------------
// COMPUTE MEAN OBLIQUITY OF THE ECLIPTIC
// EXPRESSED IN ARC SECONDS.

   $p = $t*$t;

   $eMeanSS = 84381.448 - 4680.93*$t;

   $eMeanSS -=    1.55*$p;  $p *= $t;
   $eMeanSS += 1999.25*$p;  $p *= $t;
   $eMeanSS -=   51.38*$p;  $p *= $t;
   $eMeanSS -=  249.67*$p;  $p *= $t;
   $eMeanSS -=   39.05*$p;  $p *= $t;
   $eMeanSS +=    7.12*$p;  $p *= $t;
   $eMeanSS +=   27.87*$p;  $p *= $t;
   $eMeanSS +=    5.79*$p;  $p *= $t;
   $eMeanSS +=    2.45*$p;

// -----------------------------------------------
// RETURN THE MEAN OBLIQUITY EXPRESSED IN DEGREES.

   $eMeanDeg = $eMeanSS / 3600;

   return $eMeanDeg;

} // End of  Epsilon_Mean()



// ****************************************************************************


/*

   Compute the nutation in Epsilon, Delta Epsilon or
   nutation in obliquity of the ecliptic, in degrees.

   This is the correction to apply to the MEAN value
   of the obliquity to obtain the TRUE obliquity.

   The general precision level is  ±0.001 arc sec.

   This function is based on the 1980 IAU theory.

   $JD = JD number corresponding to any date and time

   $t  = Julian time factor as reckoned from J2000
   $t2 = $t to the power of 2
   $t3 = $t to the power of 3

   ==============================================
   Nutation correction elements (1980 IAU Theory)

   $w1 = Mean elongation of the moon from the sun
   $w2 = Mean anomaly of the sun
   $w3 = Mean anomaly of the moon
   $w4 = Argument of latitude of the moon
   $w5 = Longitude of lunar ascending node

   $w  = Nutation series accumulator

*/

   Function Delta_Epsilon ($JD)
{

// COMPUTE TIME FACTOR IN JULIAN CENTURIES AS
// RECKONED FROM J2000 AND ITS POWERS.

   $T  = ($JD - 2451545) / 36525;
   $T2 = $T * $T;
   $T3 = $T * $T * $T;

// -----------------------------------------
// Compute mean lunar elongation in radians.

   $w1 = 297.85036 + 445267.11148*$T - 0.0019142*$T2 + ($T3 / 189474);
   $w1 = deg2rad($w1);

// --------------------------------------
// COMPUTE MEAN SOLAR ANOMALY IN RADIANS.

   $w2 = 357.52772 + 35999.05034*$T - 0.0001603*$T2 - ($T3 / 300000);
   $w2 = deg2rad($w2);

// --------------------------------------
// COMPUTE MEAN LUNAR ANOMALY IN RADIANS.

   $w3 = 134.96298 + 477198.867398*$T + 0.0086972*$T2 + ($T3 / 56250);
   $w3 = deg2rad($w3);

// ----------------------------------------------
// COMPUTE LUNAR ARGUMENT OF LATITUDE IN RADIANS.

   $w4 = 93.27191 + 483202.017538*$T - 0.0036825*$T2 + ($T3 / 327270);
   $w4 = deg2rad($w4);

// -----------------------------------------------------
// COMPUTE LONGITUDE OF LUNAR ASCENDING NODE IN RADIANS.

   $w5 = 125.04452 - 1934.136261*$T + 0.0020708*$T2 + ($T3 / 450000);
   $w5 = deg2rad($w5);

// ---------------------------------------------------
// COMPUTE THE NUTATION IN OBLIQUITY (ArcSec * 10000).

   $w  = cos($w5)*(92025 + 8.9*$T);
   $w += cos(2*($w4 - $w1 + $w5))*(5736 - 3.1*$T);
   $w += cos(2*($w4 + $w5))*(977 - 0.5*$T);
   $w += cos(2*$w5)*(0.5*$T - 895);
   $w += cos($w2)*(54 - 0.1*$T);
   $w += cos($w2 + 2*($w4 - $w1 + $w5))*(224 - 0.6*$T);
   $w += cos($w3 + 2*($w4 + $w5))*(129 - 0.1*$T);
   $w += cos(2*($w4 - $w1 + $w5) - $w2)*(0.3*$T - 95);
   $w += 200*cos(2*$w4 + $w5);
   $w -= 70*cos(2*($w4 - $w1) + $w5);
   $w -= 53*cos(2*($w4 + $w5) - $w3);
   $w -= 33*cos($w3 + $w5);
   $w += 26*cos(2*($w1 + $w4 + $w5) - $w3);
   $w += 32*cos($w5 - $w3);
   $w += 27*cos($w3 + 2*$w4 + $w5);
   $w -= 24*cos(2*($w4 - $w3) + $w5);
   $w += 16*cos(2*($w1 + $w4 + $w5));
   $w += 13*cos(2*($w3 + $w4 + $w5));
   $w -= 12*cos($w3 + 2*($w4 - $w1 + $w5));
   $w -= 10*cos(2*$w4 + $w5 - $w3);
   $w -= 8*cos(2*$w1 - $w3 + $w5);
   $w += 7*cos(2*($w2 - $w1 + $w4 + $w5));
   $w -= 7*cos($w3);
   $w += 9*cos($w2 + $w5);
   $w += 7*cos($w3 + $w5 - 2*$w1);
   $w += 6*cos($w5 - $w2);
   $w += 5*cos(2*($w1 + $w4) - $w3 + $w5);
   $w += 3*cos($w3 + 2*($w4 + $w1 + $w5));
   $w -= 3*cos($w2 + 2*($w4 + $w5));
   $w += 3*cos(2*($w4 + $w5) - $w2);
   $w += 3*cos(2*($w1 + $w4) + $w5);
   $w -= 3*cos(2*($w3 + $w4 + $w5 - $w1));
   $w -= 3*cos($w3 + 2*($w4 - $w1) + $w5);
   $w += 3*cos(2*($w1 - $w3) + $w5);
   $w += 3*cos(2*$w1 + $w5);
   $w += 3*cos(2*($w4 - $w1) + $w5 - $w2);
   $w += 3*cos($w5 - 2*$w1);
   $w += 3*cos(2*($w3 + $w4) + $w5);

// ----------------------------
// RETURN NUTATION IN OBLIQUITY
// EXPRESSED IN DEGREES.

   return $w / 36000000;

} // End of  Delta_Epsilon()


// ****************************************************************************

/*

   This unction computes the nutation in ecliptical longitude,
   in degrees, for any given JD argument.

*/

   function Delta_Psi ($JD)
{

// -------------------------------------------------------
// COMPUTE POWERS OF TIME IN JULIAN CENTURIES FROM J2000.0

   $T1 = ($JD - 2451545) / 36525;
   $T2 = $T1*$T1;
   $T3 = $T2*$T1;

// -----------------------------------------
// COMPUTE MEAN LUNAR ELONGATION IN RADIANS.

   $w1 = 297.85036 + 445267.11148*$T1 - 0.0019142*$T2 + ($T3 / 189474);
   $w1 = deg2rad($w1);

// --------------------------------------
// COMPUTE MEAN SOLAR ANOMALY IN RADIANS.

   $w2 = 357.52772 + 35999.05034*$T1 - 0.0001603*$T2 - ($T3 / 300000);
   $w2 = deg2rad($w2);

// --------------------------------------
// COMPUTE MEAN LUNAR ANOMALY IN RADIANS.

   $w3 = 134.96298 + 477198.867398*$T1 + 0.0086972*$T2 + ($T3 / 56250);
   $w3 = deg2rad($w3);

// ----------------------------------------------
// COMPUTE LUNAR ARGUMENT OF LATITUDE IN RADIANS.

   $w4 = 93.27191 + 483202.017538*$T1 - 0.0036825*$T2 + ($T3 / 327270);
   $w4 = deg2rad($w4);

// ----------------------------------------
// COMPUTE LUNAR ASCENDING NODE IN RADIANS.

   $w5 = 125.04452 - 1934.136261*$T1 + 0.0020708*$T2 + ($T3 / 450000);
   $w5 = deg2rad($w5);

// ---------------------------------------------
// COMPUTE THE NUTATION IN ECLIPTICAL LONGITUDE.

   $w  = sin($w5)*(-174.2*$T1 - 171996);
   $w += sin(2*($w4 + $w5 - $w1))*(-1.6*$T1 - 13187);
   $w += sin(2*($w4 + $w5))*(-2274 - 0.2*$T1);
   $w += sin(2 * $w5)*(0.2*$T1 + 2062);
   $w += sin($w2)*(1426 - 3.4*$T1);
   $w += sin($w3)*(0.1*$T1 + 712);
   $w += sin(2*($w4 + $w5 - $w1) + $w2)*(1.2*$T1 - 517);
   $w += sin(2 * $w4 + $w5)*(-0.4*$T1 - 386);
   $w += sin(2*($w4 + $w5 - $w1) - $w2)*(217 - 0.5*$T1);
   $w += sin(2*($w4 - $w1) + $w5)*(129 + 0.1*$T1);
   $w += sin($w3 + $w5)*(0.1*$T1 + 63);
   $w += sin($w5 - $w3)*(-0.1*$T1 - 58);
   $w += sin(2*$w2)*(17 - 0.1*$T1);
   $w += sin(2*($w2 + $w4 + $w5 - $w1))*(0.1*$T1 - 16);
   $w -= 301*sin(2*($w4 + $w5) + $w3);
   $w -= 158*sin($w3 - 2*$w1);
   $w += 123*sin(2*($w4 + $w5) - $w3);
   $w +=  63*sin(2*$w1);
   $w -=  59*sin(2*($w1 + $w4 + $w5) - $w3);
   $w -=  51*sin(2 * $w4 + $w3 + $w5);
   $w +=  48*sin(2*($w3 - $w1));
   $w +=  46*sin(2*($w4 - $w3) + $w5);
   $w -=  38*sin(2*($w1 + $w4 + $w5));
   $w -=  31*sin(2*($w3 + $w4 + $w5));
   $w +=  29*sin(2*$w3);
   $w +=  29*sin(2*($w4 + $w5 - $w1) + $w3);
   $w +=  26*sin(2*$w4);
   $w -=  22*sin(2*($w4 - $w1));
   $w +=  21*sin(2*$w4 + $w5 - $w3);
   $w +=  16*sin(2*$w1 - $w3 + $w5);
   $w -=  15*sin($w2 + $w5);
   $w -=  13*sin($w3 + $w5 - 2*$w1);
   $w -=  12*sin($w5 - $w2);
   $w +=  11*sin(2*($w3 - $w4));
   $w -=  10*sin(2*($w4 + $w1) + $w5 - $w3);
   $w -=   8*sin(2*($w4 + $w1 + $w5) + $w3);
   $w +=   7*sin(2*($w4 + $w5) + $w2);
   $w -=   7*sin($w3 - 2*$w1 + $w2);
   $w -=   7*sin(2*($w4 + $w5) - $w2);
   $w -=   7*sin(2*$w1 + 2*$w4 + $w5);
   $w +=   6*sin(2*$w1 + $w3);
   $w +=   6*sin(2*($w3 + $w4 + $w5 - $w1));
   $w +=   6*sin(2*($w4 - $w1) + $w3 + $w5);
   $w -=   6*sin(2*($w1 - $w3) + $w5);
   $w -=   6*sin(2*$w1 + $w5);
   $w +=   5*sin($w3 - $w2);
   $w -=   5*sin(2*($w4 - $w1) + $w5 - $w2);
   $w -=   5*sin($w5 - 2*$w1);
   $w -=   5*sin(2*($w3 + $w4) + $w5);
   $w +=   4*sin(2*($w3 - $w1) + $w5);
   $w +=   4*sin(2*($w4 - $w1) + $w2 + $w5);
   $w +=   4*sin($w3 - 2*$w4);
   $w -=   4*sin($w3 - $w1);
   $w -=   4*sin($w2 - 2*$w1);
   $w -=   4*sin($w1);
   $w +=   3*sin(2 * $w4 + $w3);
   $w -=   3*sin(2*($w4 + $w5 - $w3));
   $w -=   3*sin($w3 - $w1 - $w2);
   $w -=   3*sin($w2 + $w3);
   $w -=   3*sin(2*($w4 + $w5) + $w3 - $w2);
   $w -=   3*sin(2*($w1 + $w4 + $w5) - $w2 - $w3);
   $w -=   3*sin(2*($w4 + $w5) + 3*$w3);
   $w -=   3*sin(2*($w1 + $w4 + $w5) - $w2);

// ---------------------------
// RETURN ECLIPTICAL LONGITUDE
// EXPRESSED IN DEGREES.

   $dPsi = $w / 36000000;

   return $dPsi;

  } // End of  Delta_Psi()



// ****************************************************************************

/*
   This function computes the nutation in right ascension at the celestial
   equator, in degrees, also known as the equation of the equinoxes.

   THIS IS ALSO CALLED THE EQUATION OF THE EQUINOXES AND
   IS THE DIFFERENCE (True Equinox - Mean Equinox).

   NOTE:
   Degrees * 240 = Seconds of RA

*/

   function Delta_Equinox ($JD)
{

// ---------------------------------------------
// COMPUTE COSINE OF TRUE OBLIQUITY OF ECLIPTIC.

   $CosEpsTrue = cos(deg2rad(Epsilon_Mean($JD) + Delta_Epsilon($JD)));

// ---------------------------------------------------
// DONE.  RETURN EQUATION OF THE EQUINOXES IN DEGREES.

   return Delta_Psi($JD) * $CosEpsTrue;

} // End of  Delta_Equinox()


// ****************************************************************************

/*
   Given a distance in AUs, this function computes the equivalent distances
   in astronomical units (AUs), kilometers(km) and miles (mi).

   Mkm, Mmi, Bkm and Bmi mean millions and billions of kilometers or miles
   respectively.

   For clarity:
   1 million = 1E6
   1 billion = 1E9



*/

   function AU_To_AUKmMi ($AUs, $AUDecimals=7)

{

   $AU = trim($AUs);

   $km = $AU * 149597870.691;
   $mi = $km / 1.609344;

// ---------------------------------------------------------
// DETERMINE PREFIX: M=Millions or B=Billions of KILOMETERS.

   $factor = 1;
   $prefix = "";

   if ($km >= 1E6)  {$prefix = "M";  $factor = 1000000;}

   if ($km >= 1E9)  {$prefix = "B";  $factor = 1000000000;}

   $km /= $factor;

   $km = sprintf("%3.6f", $km) . " $prefix" . "km";

   $km = str_replace("| 0", "|  ", $km);

// ----------------------------------------------------
// DETERMINE PREFIX: M=Millions or B=Billions of MILES.

   $factor = 1;
   $prefix = "";

   if ($mi >= 1E6)  {$prefix = "M";  $factor = 1000000;}

   if ($mi >= 1E9)  {$prefix = "B";  $factor = 1000000000;}

   $mi /= $factor;

   $mi = sprintf("%3.6f", $mi) . " $prefix" . "mi";

   if ($AU >= 4) {$w = "7";} else {$w = "$AUDecimals";}

       $AU = sPrintF("%1.$w" . "f", $AU) . " AU";

   $LTd = $AU * 0.0057755183310895;

   $LTHMS = HMS_For_Days ($LTd, 3);

   $LTHMS = str_replace("00h ", "", $LTHMS);

   $w = "$AU =|$km =|$mi";

// ------------
// ZERO FILTERS

   $w = str_replace("AU|00",  "AU|  ",  $w);
   $w = str_replace("AU|0",   "AU| ",   $w);
   $w = str_replace("Mkm|00", "Mkm|  ", $w);
   $w = str_replace("Mkm|0",  "Mkm| ",  $w);
   $w = str_replace("Bkm|00", "Bkm|  ", $w);
   $w = str_replace("Bkm|0",  "Bkm| ",  $w);
   $w = str_replace("|", " ", $w);

   $w = str_replace("    ", "   ", $w);

// --------------
// Final filters.

   $w = str_replace("= 0",  "=  ",  $w);
   $w = str_replace("=  0", "=   ", $w);

// -----
// Done.

   return $w;

} // End of  AU_To_AUKmMi()


// ****************************************************************************

// This function returns the light-time in HMS
// corresponding to a given argument in AUs.

   function Light_Time_For_AU ($AU, $HMSFlag=TRUE)

{

// ---------------------------
// COMPUTE LIGHT-TIME IN DAYS.

   $LTDays = $AU * 0.0057755183310895;

// --------------------------------------------
// RETURN VALUE IN DAYS IF HMSFlag IS NOT TRUE.

   if ($HMSFlag !== TRUE) {return $LTDays;}


// ---------------------------------
// CONVERT LIGHT-TIME TO HMS STRING.

   $LTHMS = HMS_For_Days ($LTDays, 3);

// ------------------------------------------
// CUT OFF HOURS VALUE IF IT EQUATES TO ZERO.

   $LTHMS = str_replace("00h ", "", $LTHMS);

   return $LTHMS;
}

// ****************************************************************************

/*

This function converts any of several units of length or
distance into the equivalent in meters.  It makes use of
the metric length equivalents defined within this module.

It is the opposite of the Meters_To_Length() function.

----
NOTE

These computations are able to accomodate arbitrary
precision out to 105 decimals which is sufficient
for any practical usage.

---------
ARGUMENTS

$LengthVal = Numerical value of the length to be converted
$FromUnits = The units symbol corresponding to the value

The returned output is simply the equivalent length in meters.

-------------------------------------------------------
There are 16 units symbols recognized by this function.

They are:

 SYMBOL         UNITS

   A            Angstroms
   nm           Nanometers
 um or u        Micrometers (or Microns)
   mm           Millimeters
   cm           Centimeters
   in           Inches
   ft           Feet
   yd           Yards
   m            Meters
   km           Kilometers
   mi           Miles (Statute)
   nmi          Nautical miles
   LS           Light Seconds
   AU           Astronomical Units
   LY           Light Years (Based on Julian year)
   psc          Parsecs

IMPORTANT NOTE:
The units symbols used here ARE case sensitive.

ERRORS:
An error occurs if the argument cannot be resolved
into a valid numerical value and units symbol.  On
error, FALSE is returned.

*/

   Function Length_To_Meters ($LengthVal, $FromUnits)
{

// ------------------------------
// Set arbitrary precision limit.

   $nDec = 105;

// -----------------------------
// Get the numerical value part.
// Error if not a numerical value.

   $x = trim($LengthVal);

   if ($x == "") {$x = "0.0";}

   if (!is_numeric($x)) {return FALSE;}

   if (StrPos($x, ".") === FALSE) {$x = "$x.0";}

// ----------------
// Get units symbol.

   $UnitsSymbol = trim($FromUnits);

// ---------------------------------------------------
// Initialize factor to empty string.   If it is still
// empty on exit from the switch block, below then it
// means that the units symbol was not recognized as
// valid.

   $f = "";

// --------------------------------------
// Determine the conversion factor to use
// from the units symbol argument.
//
// NOTE: These symbols ARE case sensitive.

   switch ($UnitsSymbol)
  {
   case "A"   : $f = M_PER_A;    break;
   case "um"  : $f = M_PER_UM;   break;
   case "u"   : $f = M_PER_UM;   break;
   case "nm"  : $f = M_PER_NM;   break;
   case "mm"  : $f = M_PER_MM;   break;
   case "cm"  : $f = M_PER_CM;   break;
   case "in"  : $f = M_PER_IN;   break;
   case "ft"  : $f = M_PER_FT;   break;
   case "yd"  : $f = M_PER_YD;   break;
   case "m"   : $f = M_PER_M;    break;
   case "km"  : $f = M_PER_KM;   break;
   case "mi"  : $f = M_PER_MI;   break;
   case "nmi" : $f = M_PER_NMI;  break;
   case "LS"  : $f = CLIGHT;     break;
   case "AU"  : $f = M_PER_AU;   break;
   case "LY"  : $f = M_PER_LY;   break;
   case "pc"  : $f = M_PER_PC;   break;
  }

// ------------------------------------------
// Error if conversion factor is still empty,
// which means that the units symbol is not
// found in the table of valid symbols.
   If ($f === FALSE) {return $f;}

// ----------------------------------------------
// Otherwise, return the equivalent meters value
// by multiplying the value of the argument by
// the conversion factor $f.
   $w = bcMul("$x", "$f", $nDec);

// -----
// Done.
   return RTrim(RTrim($w, "0"), ".");

}  // End of Length_To_Meters()


// ****************************************************************************


/*

This function converts a length or distance value given in
meters into its equivalent in any of the 16 length units
recognized by this module.

It is the opposite of the Length_To_Meters() function and
recognizes the same length units symbols.

NOTE:
The computations are able to accomodate arbitrary
precision out to 105 decimals which is sufficient
for any practical usage.

ARGUMENTS
$metersArg =  Value in meters that will be converted
              to the specified output units.

$toUnits   =  Units symbol for the output value.  This
              symbol will NOT be attached to the output.
              It will simply be a numeric value that is
              understood to be in the specified units.

There are 16 units symbols recognized by this function.
They are:

 SYMBOL         UNITS

   A            Angstroms
   nm           Nanometers
 um or µ        Micrometers (or Microns)
   mm           Millimeters
   cm           Centimeters
   in           Inches
   ft           Feet
   yd           Yards
   m            Meters
   km           Kilometers
   mi           Miles (Statute)
   nmi          Nautical miles
   LS           Light Seconds
   AU           Astronomical Units
   LY           Light Years (Based on Julian year)
   pc           Parsecs
   LS           Light Seconds

IMPORTANT NOTE
The units symbols used here ARE case sensitive.

ERRORS
An error occurs if the argument cannot be resolved
into a valid numerical value and units symbol.  On
error, FALSE is returned.

*/


   Function Meters_To_Length ($MetersVal, $ToUnits)

{

// ------------------------------
// Set arbitrary precision limit.

   $nDec = 105;

// ------------------------------
// Read value of meters argument.

   $m = Trim("$MetersVal");

// -------------------------------------
// Error if meters value is non-numeric.

   If (!Is_Numeric($m)) {Return FALSE;}

   if (StrPos($m, ".") === FALSE) {$m = "$m.0";}

// --------------------------------------
// Read the output units symbol argument.

   $UnitsSymbol = Trim($ToUnits);

// ---------------------------------------------------
// Initialize factor to empty string.   If it is still
// empty on exit from the switch block below, then it
// means that the units symbol was not found in the
// table of valid units.

   $f = "";

// --------------------------------------
// Determine the conversion factor to use
// from the units symbol argument.
// THESE SYMBOLS ARE CASE SENSITIVE.

   switch ($UnitsSymbol)
  {
   case "A"   : $f = M_PER_A;    break;
   case "um"  : $f = M_PER_UM;   break;
   case "u"   : $f = M_PER_UM;   break;
   case "nm"  : $f = M_PER_NM;   break;
   case "mm"  : $f = M_PER_MM;   break;
   case "cm"  : $f = M_PER_CM;   break;
   case "in"  : $f = M_PER_IN;   break;
   case "ft"  : $f = M_PER_FT;   break;
   case "yd"  : $f = M_PER_YD;   break;
   case "m"   : $f = M_PER_M;    break;
   case "km"  : $f = M_PER_KM;   break;
   case "mi"  : $f = M_PER_MI;   break;
   case "nmi" : $f = M_PER_NMI;  break;
   case "LS"  : $f = CLIGHT;     break;
   case "AU"  : $f = M_PER_AU;   break;
   case "LY"  : $f = M_PER_LY;   break;
   case "pc"  : $f = M_PER_PC;   break;
  }

// ------------------------------------------
// Error if conversion factor is still empty.

   If ($f == "") {return FALSE;}

// ----------------------------------------------
// Otherwise, return the equivalent of the given
// meters value by dividing the value of the
// argument by the conversion factor $f.

   $w = bcDiv ($m, $f, $nDec);

   return RTrim(RTrim($w, "0"), ".");

}  // End of Meters_To_Length()


// ****************************************************************************

/*

   This function checks to see if a given length units symbol is among
   those currently recognized.  This list can be modified as needed.

   It is a Boolean test and returns TRUE if the units symbol is valid
   or FALSE otherwise.

*/
   function Is_Valid_Length_Unit ($UnitsSymbolStr)

{

   $UnitsSymbols = "A  NM AU U  MU MM CM IN FT YD M  KM MI NMILS AU LY PC ";

   $u = trim(strtoupper($UnitsSymbolStr));

   for ($i=0;   $i < 18;   $i++)

   {
    if ($u == trim(substr($UnitsSymbols, 3*$i, 3))) {return TRUE;};
   }

   return FALSE;

}

// ****************************************************************************

/*

 This function converts from one length unit into another, such as feet to
 centimeters, yards to meters, miles to kilometers, etc.

*/

   function From_Units_To_Units ($FromValStr, $FromUnitsStr, $ToUnitsStr)

 {
   $L1 = Length_To_Meters ($FromValStr, $FromUnitsStr);
   $w  = Meters_To_Length ($L1, $ToUnitsStr);

   $L2 = bcRound($w, 16);

   if (abs($w) < 1E-08) {$L2 = bcRound($w, 24);}
   if (abs($w) < 1E-16) {$L2 = bcRound($w, 32);}
   if (abs($w) < 1E-24) {$L2 = bcRound($w, 40);}

   $L2 = RTrim(RTrim($L2, "0"), ".");

   return $L2;

 } // End of  From_Units_To_Units()

// ****************************************************************************

/*
   This function converts from one temperature scale into another.  The scales
   recognized are the Fahrenheit (F), Celsius (C), Kelvin (K) and Rankine (R)
   scales.

   $TemperatureValue = Numerical value of the temperature
          $FromScale = From scale symbol (F,C,K,R)
          $ToScale   = To scale symbol (F,C,K,R)
*/


   function Temp_To_Temp ($TemperatureValue, $FromScale, $ToScale)

{

// -----------------------------------
// GET NUMERICAL VALUE OF TEMPERATURE.
// ERROR IF NON-NUMERIC.

   $t  = trim($TemperatureValue);

   if (is_numeric($t))

  {

// --------------------------------------
// CONVERT INPUT ($FromScale) TO K SCALE.

   switch (StrToUpper(trim($FromScale)))
  {
   case "F" : $t = (5*($t - 32) / 9) + 273.15;  break;

   case "C" : $t = $t + 273.15;  break;

   case "K" : $t = $t;  break;

   case "R" : $t = (5*($t - 491.67) / 9) + 273.15;  break;

   default  : return "";
  }

// -------------------------------
// CONVERT K TO OUTPUT ($ToScale).

   switch (StrToUpper(trim($ToScale)))
  {
   case "F" : return (9 * ($t - 273.15) / 5) + 32;

   case "C" : return $t - 273.15;

   case "K" : return $t;

   case "R" : return (9 * ($t - 273.15) / 5) + 491.67;

   default  : return "";
  }

  } //End of  if (is_numeric)


else


  {
   return "";
  }

} // End of  Temp_To_Temp()

// ****************************************************************************
// ************************************************************************
// ************************************************************************

   function X_ISOymd_For_JD ($JD, $CalMode=1)
{

// ------------------------------------------------------
// COMPUTE JD12 FROM ASTRONOMICAL JD AND THEN COMPUTE THE
// CORRSPONDING ISO INTEGER-ENCODED DATE FOR JD12.

   $a = floor($JD + 0.5);
   $b = $CalMode*floor(($a - 1867216.25) / 36524.25);
   $c = $a + $CalMode*($b - floor($b/4) + 1);
   $e = $c + 1524;
   $f = floor(($e - 122.1) / 365.25);
   $g = floor(365.25 * $f);
   $h = floor(($e - $g) / 30.6001);

   $m = $h - 12*floor($h/14) - 1;
   $d = $e - $g - floor(30.6001 * $h);

   $w = $f - 4716 + floor((14-$m) / 12);
   $y = ($w > 0) ? $w : $w-1;

   $wMinus1 = $w-1;


   $YearSignVal = ($y < 0) ? -1 : 1;

   $ISOymd = $YearSignVal*(10000*abs($y) + 100*$m + $d);

   $Mmm = Month_String($m);

   if ($b == "-0") {$b=0;}

   $dd = sprintf("%02d", $d);

   $out =
"
 JD = $JD
 CalMode = $CalMode

 a = $a = floor($JD + 0.5)
 b = $b = $CalMode*floor(($a - 1867216.25) / 36524.25)
 c = $c = $a + $CalMode*($b - floor($b/4) + 1)
 e = $e = $c + 1524
 f = $f = floor(($e - 122.1) / 365.25)
 g = $g = floor(365.25 * $f)
 h = $h = floor(($e - $g) / 30.6001)

 m = $m = $h - 12*floor($h/14) - 1
 d = $d = $e - $g - floor(30.6001 * $h)

 w = $w = $f - 4716 + floor((14-$m) / 12)
 y = $y = ($w > 0) ? $w:$wMinus1
 YearSignVal = $YearSignVal = ($y < 0) ? -1:1

ISOymd = $ISOymd = $YearSignVal*(10000*abs($y) + 100*$m + $d)
       = $y $Mmm $dd
";

   return "<PRE>$out</PRE>";

} // End of  x_ISOymd_For_JD()



// ************************************************************************
// ************************************************************************




   function x_JD_For_ISOymd ($ISOymd, $CalMode=1)
{

   $BCAD = ($ISOymd < 0)? "B.C." : "A.D.";

   $CalendarMode = ($CalMode == 1) ? "Gregorian" : "Julian";

// ----------------------------------------------
// EXTRACT INDIVIDUAL DATE ARGUMENTS (y,m,d) FROM
// WITHIN ISO INTEGER-ENCODED DATE ARGUMENT.

   $u = abs($ISOymd);
   $v = floor($u / 10000);

   $YearSignVal = ($ISOymd < 0) ? -1 : 1;

   $y = $YearSignVal * $v;
   $m = floor(($u - 10000*$v) / 100);
   $d = $u - 10000*$v - 100*$m;

// -------------------------------------------------
// COMPUTE THE JD NUMBER FOR 12h ON GIVEN DATE. THIS
// NUMBER WILL ALWAYS EQUATE TO AN INTEGER VALUE.

   $w = ($y < 0) ? $y+1 : $y;

   $yPlus1 = $y+1;

   $a = floor((14-$m) / 12);
   $b = $w - $a;
   $c = floor($b/100);

   $Mmm = Month_String($m);

   $e = floor(30.6001*(12*$a + $m + 1));
   $f = floor(365.25*($b + 4716)) - 1524;
   $g = $CalMode*(floor($c/4) - $c + 2) + $d;

   $gLine = str_replace("- -", "+ ", "$CalMode*(floor($c/4) - $c + 2) + $d");

   $dd = sprintf("%02d", $d);

   $z = "$e + $f + $g";
   $z = str_replace("+ -", "- ", $z);

   $h = $e + $f + $g;

   $JD12 = $h;

   $JD00 = $JD12 - 0.5;

   $out =
"
 ISOymd  = $ISOymd  ($y $Mmm $dd)
 CalMode = $CalMode ($CalendarMode)

 -------------------------------------------------
 EXTRACT THE DATE ELEMENTS (y, m, d) FROM (ISOymd)

 YearSignVal = $YearSignVal ($BCAD year) = (ISOymd < 0) ? -1 : 1

 u = $u = abs(ISOymd)
 v = $v = floor(u / 10000)

 y = $y = $YearSignVal * $v
 m = $m = floor(($u - 10000*$v) / 100)
 d = $d = $u - 10000*$v - 100*$m

 --------------------------------------
 ADJUST MATHEMATICAL YEAR (w) FOR BC/AD

 w = $w = ($y < 0) ? $yPlus1 : $y

 --------------------------------------------------------------------------
 JD FOR MIDPOINT OF DATE (12h) = STANDARD CALENDRICAL JD FOR DATE (INTEGER)

 a = $a = floor((14 - $m) / 12)
 b = $b = $w - $a
 c = $c = floor($b/100)

 JD12 = $e = floor(30.6001*(12*$a + $m + 1))
      + $f = floor(365.25*($b + 4716)) - 1524
      + $g = $gLine
      = $JD12

 ------------------------------
 JD FOR BEGINNING OF DATE (00h)

 JD00 = $JD00 = JD12 - 0.5
";

   return "<PRE>$out</PRE>";

} // End of  x_JD_For_ISOymd()

// ************************************************************************
/*

========================================================
This function converts geocentric ecliptical coordinates
into the corresponding geocentric equatorial coordinates.

Angular arguments are in decimal degrees and results are
returned in decimal degrees.


---------
ARGUMENTS

$EclLngDeg = Geocentric ecliptical longitude in degrees.
$EclLatDeg = Geocentric ecliptical latitude in degrees.
$EpsDeg    = Obliquity of the ecliptic in degrees.


------
ERRORS

This function does NOT check for invalid arguments.

*/



   function Ecl_Lng_Lat_To_Equ_RA_Decl ($EclLngDeg, $EclLatDeg, $EpsDeg)

  {

// ------------------------------
// Convert input ecliptical angle
// arguments into radians.
   $Lng = Deg2Rad(trim($EclLngDeg));
   $Lat = Deg2Rad(trim($EclLatDeg));
   $Eps = Deg2Rad(trim($EpsDeg));

// -------------------------------------
// Compute the equatorial RA in degrees.
   $y = sin($Lng)*cos($Eps) - tan($Lat)*sin($Eps);
   $x = cos($Lng);
   $RA = Rad2Deg(ATan2($y, $x));
   if ($RA < 0) {$RA += 360;}

// -----------------------------------
// Compute the equatorial declination.
   $w = ASin(sin($Lat)*cos($Eps) + cos($Lat)*sin($Lng)*sin($Eps));
   $decl = Rad2Deg($w);

// ---------------------------------------------
// Done.  Return the RA and declination, both in
// degrees, in a space delimited data vector.
   return "$RA $decl";

  } // End of  Ecl_Lng_Lat_To_Equ_RA_Decl()





// ****************************************************************************

// This function pad a string on the right
// with a given number of spaces.

   function RPad($ArgStr, $PadLen)
{
   $s = trim($ArgStr);

   return substr($s . str_repeat(" ", $PadLen), 0, $PadLen);
}

// ****************************************************************************

// NEW CALENDAR TABLE

   function Cal_Table ($ISOymd, $HiColor="cyan", $CalMode=1)

{

// Handle bad date
   if (!Is_Valid_Date($ISOymd, $CalMode))

   {
     return "\n<TABLE><TR ALIGN='center'><TD>BAD DATE</TD></TR></TABLE>\n";
   }


// ---------------------------------------------
// EXTRACT INDIVIDUAL DATE ELEMENTS (y,m,d) FROM
// WITHIN INTEGER ENCODED DATE ARGUMENT (ymd).

   $JD = JD_For_ISOymd($ISOymd, $CalMode);

   $CalendarMode = ($CalMode == 0)? "J" : "G";

   $u = abs($ISOymd);
   $w = floor($u / 10000);

   $y = (($ISOymd < 0) ? -1 : 1) * $w;
   $m = floor(($u - 10000*$w) / 100);
   $d = ($u - 10000*$w - 100*$m);

   $DoW1 = ((($JD + 1) % 7) + 7 - (($d-1) % 7)) % 7;

   $HiDay    = $d;
   $mDays    = Days_In_Month ($y, $m, $CalMode);
   $mString  = Month_String($m);

   $era = ($y < 0)? " BC":" AD";   if ($y > 1300) {$era = "";}

   $yEra = abs($y) . $era;

   $CalHeader = "$CalendarMode &nbsp; $yEra &nbsp;&nbsp;&nbsp; $mString";

   return Calendar_Matrix ($DoW1, $mDays, $HiDay, $CalHeader, $HiColor);

}


// ************************************************************************


/*

 This function returns a calendar in the form of an HTML
 table for the month containing the given date .

 THIS FUNCTION IS ALSO VALID FOR PROLEPTIC DATES.

 $y     = Year number argument  (1 to 32767)
 $m     = Month number argument (1 to 12)

 $JD1   = JD number of 1st day of month
 $HDay  = Date to highlight within calendar (0 = NONE)
 $MName = Name of given month
 $DoW1  = Day of week code (0 to 6) for 1st of month
 $MDays = Number of days in given  month

 The optional parameter $hday is the day of the month to
 be highlighted in the calendar display. If ($HDay == 0),
 then no date will be highlighted.

*/


Function Calendar_Matrix ($DoW1, $MDays, $HiliteDay, $CalTitle ="", $TitleColor="cyan")

{

   if (trim($TitleColor) == ""){ $TitleColor = "cyan";}

// ---------------------------------
// BEGIN CALENDAR MATRIX CONSTRUCTION

   $CalTable =
"<TABLE BGCOLOR='black' CELLPADDING='2' CELLSPACING='1'>\n
<TR BGCOLOR=\"$TitleColor\"><TD COLSPAN='7' ALIGN='center'><B>$CalTitle</B></TD></TR>\n
<TR BGCOLOR='#F0F0F0'><TD WIDTH='36' ALIGN='center'>Sun</TD><TD WIDTH='36' ALIGN='center'>Mon</TD><TD WIDTH='36' ALIGN='center'>Tue</TD><TD WIDTH='36' ALIGN='center'>Wed</TD><TD WIDTH='36' ALIGN='center'>Thu</TD><TD  WIDTH='36' ALIGN='center'>Fri</TD><TD WIDTH='36' ALIGN='center'>Sat</TD></TR>\n<TR>\n";

// ---------------------------------------------
// FILL ANY BLANK CELLS AT BEGINNING OF CALENDAR
// MATRIX IF MONTH DOES NOT START ON A SUNDAY.

   for ($i=1;  $i <= $DoW1;   $i++)
       {$CalTable .= "<TD BGCOLOR='white'>&nbsp;</TD>\n";}

// ----------------------------------
// FILL IN CALENDAR DAY NUMBER CELLS.

   for ($day=1;   $day <= $MDays;   $day++)

{

   $BgC = ($day != $HiliteDay)? "white" : "$TitleColor";

   if ($BgC == "$TitleColor")
      {$Bold1 = "<B>"; $Bold2 = "</B>";}
   else
      {$Bold1 = $Bold2 = "";}

   $CalTable .= "<TD BGCOLOR=\"$BgC\" ALIGN='center'>$Bold1$day$Bold2";

   if (($day + $DoW1 ) % 7 == 0)
      {$CalTable .= "</TD>\n</TR>\n<TR>\n";}
   else
      {$CalTable .= "</TD>\n";}
}


// ----------------------------------------------
// FILL ANY BLANK CELLS AT END OF CALENDAR MATRIX
// IF MONTH DOES NOT END ON A SATURDAY.

   $DoW = ($DoW1 + $MDays) % 7;

   $DoWEnd = ($DoW + ($MDays - 0) % 7) % 7;

   for ($i=0;   $i < 7-$DoW;   $i++)  {$CalTable .= "<TD BGCOLOR='white'>&nbsp;</TD>\n";}

// --------------------
// CLOSE OUT THE TABLE.

   $CalTable .= "</TR>\n</TABLE>\n";

// ------------------------------------------
// PATCH TO DELETE REDUNDANT EMPTY TABLE ROW.

   $CalTable = Str_Replace("<TR>\n</TR>", "", $CalTable);

// -----
// DONE.

   return $CalTable;

} // End of  Calendar_Matrix()

// ************************************************************************

// Calendar for a given year/month.  Neg year = BC year.
//
// CalMode = Calendar mode (0=Julian or 1=Gregorian=Default)


   function Calendar_Text ($y, $m, $CalMode=1)

{

// Read input arguments and construct
// encoded calendar date.

   $mm = SPrintF("%02d", $m);

   $d = 1;      $dd = "01";

   $ISOymd = "$y$mm$dd";


// -----------------------------------------------
// GET PARAMETERS NEEDED TO CREATE CALENDAR TABLE.

   $JD1     = JD_For_ISOymd ($ISOymd, $CalMode);
   $DoW1    = ($JD1 + 1) % 7;
           $MName   = Month_String($m);
   $NumDays = Days_In_Month ($y, $m, $CalMode);


   $PadSpaces = Str_Repeat(" ", 20 - (StrLen($MName)+StrLen($y)));
   $line = "";

   $CalStr = "";
   $WDays = "Su Mo Tu We Th Fr Sa";

   for ($i=1;  $i <= $DoW1;   $i++) {$CalStr .= "&nbsp;&nbsp;&nbsp;";}

   for ($d=1;   $d <= $NumDays;   $d++)
       {
        if ($d < 10) {$p = "&nbsp;";} else {$p = "";}
            $CalStr .= $p . "$d ";
        if (($d + $DoW1 ) % 7 == 0) {$CalStr .= "\n";}
       }


   $calendar =  trim("$line\n$y$PadSpaces$MName\n\n$WDays\n$CalStr\n$line");

   return "$calendar";

} // End of  Calendar_Text()


// ************************************************************************

   function Days_In_Month ($y, $m, $CalMode=1)
{

// Convert calendar year into working mathematical year.
   $w = ($y < 0) ? $y+1 : $y;


// Compute leap year flag according to calendar mode.
   if ($CalMode == 0)
      {
       $leap = ($w % 4 == 0)? 1:0;
      }
   else
      {
       $leap = ((!($w % 4) && ($w % 100)) || !($w % 400))? 1:0;
      }

// Compute days in given month.
   $mDays = 30 - (($m < 8)? -1:1)*($m % 2) + floor($m/8)
          - (($m == 2)? $m:0) + (($m == 2 && $leap == 1)? 1:0);

   return $mDays;

} // End of  Days_In_Month(...)


// ****************************************************************************

   function DoW_String ($DoWarg)
{

// -------------------------
// DEFINE DoW NAMES TABLE.
// UNIFORM FIELD SIZE=9

   $DoWs = "Sunday   Monday   Tuesday  WednesdayThursday Friday   Saturday ";

// -----------------------------------------
// IF DoW ARGUMENT IS IN THE CORRECT NUMERIC
// RANGE, THEN RETURN THE MONTH NAME STRING.

// UNPAD ANY ZERO-PADDED MONTH VALUE.
   $w = intval("$DoWarg");

   if ($w >= 0 && $w < 7)
      {return trim(substr($DoWs, 9*$w, 9));}
   else
      {return "";}


} // End of  DoW_String()


// ************************************************************************




/*

   This function converts decimal days into a
   time data vector in the general format:

   "wk days hours minutes seconds"

   -------
   EXAMPLE

   input arguments  = (171.412935756, 3)

   output = 24wk 3d 09h 54m 37.649s


*/


   function WkDHMS_For_Days ($DaysArg, $ssDecimals=0)
{

// ------------------------------------
// GET WORKING VALUE OF NUMERICAL INPUT
// STRING, ASSUMED TO BE IN DECIMAL DAYS.

   $days = trim($DaysArg);

// ----------------------------
// EQUATE AN EMPTY INPUT STRING
// TO THE DIGIT ZERO.

   if ($days == "") {$days = 0;}

// ------------------------
// REMEMBER NUMERICAL SIGN.

   $sign = ($days < 0) ? -1 : +1;

// --------------------------------------------------
// CONVERT WORKING VALUE ($DecDays) INTO ITS ABSOLUTE
// VALUE AT 24 DECIMALS OF PRECISION.

   $days = bcMul($sign, $days, 24);

// ---------------------------------------------------
// COMPUTE WEEKS, RESIDUAL DAYS AND FRACTION OF A DAY.

   $wk = bcDiv($days, "7");
   $rd = bcSub($days, bcMul($wk, "7"), 24);
    $d = bcAdd($rd, "0");
   $DayFrac = bcSub($rd, $d, 16);

// ----------------------------------
// COMPUTE HMS TIME STRING EQUIVALENT
// TO ANY RESIDUAL DAY FRACTION.

   $hms = HMS_For_Days ($DayFrac, ($ssDecimals > 0) ? $ssDecimals : 0);

// ------------------------------------
// CONSTRUCT OUTPUT DATA VECTOR STRING,
// RECALLING ORIGINAL NUMERICAL SIGN.

   $w = "$wk" . "wk  $d" . "d  $hms";

   $WkDHMS = ($sign < 0) ? "-$w" : $w;

   $w1 = substr($WkDHMS, 0, 4);
   $w2 = substr($WkDHMS, 0, 5);

   if ($w1 === "0wk " ) {$WkDHMS = str_replace($w1, "",  $WkDHMS);}
   if ($w2 === "-0wk ") {$WkDHMS = str_replace($w2, "-", $WkDHMS);}

   return $WkDHMS;


} // End of WkDHMS_For_Days()


// ************************************************************************

// ****************************************************************************

// ****************************************************************************

// ****************************************************************************

// ****************************************************************************














// ****************************************************************************
// ****************************************************************************

/*
   THIS FUNCTION MUST BE THE FINAL FUNCTION CONTAINED WITHIN
   THIS MODULE AND NO OTHER FUNCTIONS MUST FOLLOW IT.

   This function scans and returns a listing of all of the custom
   definitions and functions contained within the target lab module.

*/
   function Lab_Module_Info ($LabModuleFilePath)

{
   global $ModuleVersion;

   $ModuleLines      = file("$LabModuleFilePath");
   $ModuleLinesCount = count($ModuleLines);

   $LabModuleFileName = str_replace("../",   "", $LabModuleFilePath);
   $LabModuleFileName = str_replace("core/", "", $LabModuleFileName);


// ----------------------------------------------------
// GENERATE LIST OF ALL CUSTOM CONSTANTS WITHIN MODULE.

   $ConstantsList  = "";
   $ConstantsCount = 0;

   for ($i=0;   $i < $ModuleLinesCount;   $i++)
       {
        $ModuleLine = trim($ModuleLines[$i]);
        $ModuleLine = str_replace(" ", "", $ModuleLine);

        if (StrToLower(substr($ModuleLine, 0, 8)) == 'define("')
           {
            $w = trim(substr($ModuleLine, 8, strlen($ModuleLine)));
            $w = str_replace('",', " = ", $w);

            $ParenthesisPointerR = strpos($w, ")");

            $w = substr($w, 0, $ParenthesisPointerR);

            $ConstantsList .= " $w\n";

            $ConstantsCount++;
           }
       }


// ----------------------------------------------------
// GENERATE LIST OF ALL CUSTOM FUNCTIONS WITHIN MODULE.

   $FunctionsList  = "";
   $FunctionsCount = 0;

   for ($i=0;   $i < $ModuleLinesCount;   $i++)
       {
        $ModuleLine = trim($ModuleLines[$i]);

        if (StrToLower(substr($ModuleLine, 0, 8)) == "function")
           {
            $w = trim(substr($ModuleLine, 8, strlen($ModuleLine)));

            $FunctionsList .= " $w\n";

            $FunctionsCount++;
           }
       }

   $FunctionsList = trim($FunctionsList);


// ---------------------------------
// RETURN FINAL LISTING CODE STRING.

   return

"<B><PRE>
 ************************************************
 $LabModuleFileName
 $ModuleVersion
 Synopsis of constants and functions
 ************************************************
 ************************************************
 THE FOLLOWING $ConstantsCount CUSTOM CONSTANTS ARE DEFINED:

$ConstantsList
 ************************************************
 ************************************************
 THE FOLLOWING $FunctionsCount CUSTOM FUNCTIONS ARE DEFINED:

 $FunctionsList

</PRE></B>";

} // End of  Lab_Module_Info ()

// ****************************************************************************
// ****************************************************************************



?>



